<?php
/*
 * Copyright (c) 2013, webvariants GbR, http://www.webvariants.de
 *
 * This file is released under the terms of the MIT license. You can find the
 * complete text in the attached LICENSE file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

class WV_Filter_Article_CategoryID extends WV_Filter_Or implements WV_Filter_Interface {
	public function __construct($id, $comparator = '=', $recursive = false) {
		$filters = array(
			new WV_Filter_Value($id, $comparator, function($value) { return $value->getParentId(); }),
			new WV_Filter_Article_ID($id, $comparator)
		);

		if ($recursive) {
			if (!in_array($comparator, array('=', '!='))) {
				throw new WV_Exception_Filter(t('devutils_filters_base_unknown', $comparator));
			}

			$comparator = $comparator === '=' ? 'LIKE' : 'NOT LIKE';
			$filters[]  = new WV_Filter_Value("%|$id|%", $comparator, function($value) { return $value->getPath(); });
		}

		parent::__construct($filters);
	}
}
